LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.NUMERIC_STD.ALL;

LIBRARY work;
USE work.YOLO_pkg.ALL;

ENTITY L4_BNROM IS
    PORT (
        clk : IN STD_LOGIC;
        coefs : OUT STD_LOGIC_VECTOR(63 DOWNTO 0); -- Instruction bus
        address : IN unsigned(5 DOWNTO 0));
END L4_BNROM;

ARCHITECTURE RTL OF L4_BNROM IS

    TYPE ROM_mem IS ARRAY (0 TO 63) OF STD_LOGIC_VECTOR(63 DOWNTO 0);

    --kernel2(bias&scale) & kernel1(bias&scale)

    signal ROM_content : ROM_mem :=
    (0=>"0000010100111111"&"0000001001101110"&"1111111111001010"&"0000001001001010",
    1=>"0000000010100100"&"0000000111001101"&"0000000101001110"&"0000001001011101",
    2=>"1111111000111111"&"0000001011100001"&"0000011110000101"&"0000000110110100",
    3=>"1111111110000101"&"0000001001110101"&"0000011001000000"&"0000000111010101",
    4=>"1111101010011001"&"0000001101101111"&"0000000011111100"&"0000001011100110",
    5=>"1111111011111000"&"0000001010011011"&"1111111110110111"&"0000001010100011",
    6=>"0000000000011101"&"0000001100001110"&"0000000110111101"&"0000001010100001",
    7=>"1111100011001100"&"0000001101000011"&"0000001000111011"&"0000001010101011",
    8=>"0000000101011110"&"0000001000110011"&"0000001100110100"&"0000001010000000",
    9=>"0000000110011111"&"0000000110111010"&"0000000110011010"&"0000001010101001",
    10=>"0000000110110110"&"0000000111101000"&"1111111011001111"&"0000001100010000",
    11=>"1111111110101100"&"0000001000111101"&"0000000010000110"&"0000001010100010",
    12=>"1111011110010011"&"0000000101110111"&"0000000000011011"&"0000001100011101",
    13=>"0000000101011101"&"0000001001001110"&"1111101100010111"&"0000001000001111",
    14=>"1111111110101001"&"0000000110111110"&"0000000000010101"&"0000001101110111",
    15=>"1111110111000111"&"0000001001001100"&"1111111111010111"&"0000001100001100",
    16=>"0000001101111011"&"0000000111000010"&"0000011100110000"&"0000001001010100",
    17=>"1111111110011101"&"0000001001111110"&"0000001010111111"&"0000000111001011",
    18=>"0000001001011000"&"0000001010100101"&"0000000011001011"&"0000000111001111",
    19=>"1111110001001001"&"0000000110011001"&"0000000100010000"&"0000001001100101",
    20=>"1111111011010010"&"0000001010000111"&"0000000110010101"&"0000001010001001",
    21=>"0000000100000010"&"0000001100010001"&"0000010101110010"&"0000000101111010",
    22=>"0000011100110110"&"0000001011111000"&"1111011110010100"&"0000001100010111",
    23=>"1111111000011111"&"0000001101011101"&"1111000111111110"&"0000010000100010",
    24=>"1111110010101110"&"0000010000001110"&"0000000101101101"&"0000001100010111",
    25=>"0000000100011011"&"0000001010111111"&"1111111101000001"&"0000001010100111",
    26=>"1111111010010010"&"0000001011010001"&"1111111001110000"&"0000001101010100",
    27=>"1111111001101000"&"0000001110001010"&"0000000100101010"&"0000001011110000",
    28=>"1111111011110011"&"0000001010001101"&"1111111011100000"&"0000001100110101",
    29=>"0000000000100110"&"0000001001001011"&"0000000100010101"&"0000000111010111",
    30=>"0000010110000000"&"0000001000011011"&"1111111101111111"&"0000001010000000",
    31=>"0000001011001100"&"0000001011001000"&"0000001001111001"&"0000001100100111",
    32=>"1111110100110101"&"0000001010110101"&"0000000101111000"&"0000001000011000",
    33=>"1111111011010110"&"0000001011000100"&"1111111100011100"&"0000001001001001",
    34=>"1111110001001001"&"0000001100100100"&"1111111101010001"&"0000001010101101",
    35=>"0000010100110000"&"0000000111100100"&"0000000001011001"&"0000001100100000",
    36=>"0000001011001010"&"0000000101111110"&"1111111001000100"&"0000001000100110",
    37=>"0000000011100111"&"0000001010111101"&"1111110010001010"&"0000001100001001",
    38=>"1111011000001011"&"0000001001000101"&"0000010100110001"&"0000001010010010",
    39=>"1111111001111000"&"0000001010110101"&"0000001000000001"&"0000001011110110",
    40=>"1111111001100000"&"0000001010100001"&"0000010100101101"&"0000000111110000",
    41=>"0000001110101111"&"0000001001011100"&"0000000000100000"&"0000001010100100",
    42=>"0000010100111110"&"0000001011001110"&"0000000101111101"&"0000001001011101",
    43=>"0000000111010110"&"0000001010110011"&"0000000010011100"&"0000001010110000",
    44=>"0000000100100101"&"0000001100000001"&"0000000001000100"&"0000001001100011",
    45=>"0000000111001010"&"0000001001000110"&"0000001111100011"&"0000001100100011",
    46=>"1111110010001000"&"0000001101011100"&"1111111110000011"&"0000001000010110",
    47=>"1111111100001110"&"0000001001101100"&"1111110000111010"&"0000001001101100",
    48=>"0000000101000011"&"0000001011011110"&"0000010011100110"&"0000000111111111",
    49=>"0000001010010100"&"0000000111010011"&"1111111101111111"&"0000001011010011",
    50=>"1111111000011011"&"0000001011010110"&"0000010011110100"&"0000001011000001",
    51=>"0000000100101011"&"0000000111011011"&"1111111111000110"&"0000001010101111",
    52=>"0000001000100000"&"0000000101110000"&"0000000110010001"&"0000001101100101",
    53=>"1111111000101110"&"0000001001101110"&"1111111110001011"&"0000001010001110",
    54=>"1111001010110101"&"0000001011010110"&"1111101110110011"&"0000000101100100",
    55=>"0000000000111111"&"0000001001110111"&"1111111010110110"&"0000000110101101",
    56=>"1111111111101100"&"0000001010111010"&"0000011001101011"&"0000001011100010",
    57=>"0000000001111110"&"0000001000001001"&"1111111111101010"&"0000001001101101",
    58=>"0000000111110110"&"0000001010011011"&"0000000010100110"&"0000001010110000",
    59=>"0000001110110101"&"0000001000111001"&"1111111100000101"&"0000001101000101",
    60=>"0000001011001101"&"0000000101101100"&"1111101111010001"&"0000001100101011",
    61=>"1111111110001111"&"0000001100110111"&"1111011001101111"&"0000001001111101",
    62=>"0000001000001001"&"0000001001101010"&"1111101110100010"&"0000001111000111",
    63=>"0000010000010110"&"0000001011010000"&"1111111010001100"&"0000001101010111"
    );
    attribute rom_style : string; 
    attribute rom_style of ROM_content : signal is "block";
BEGIN
proc_name : PROCESS (clk)
BEGIN
  IF rising_edge(clk) THEN
    coefs <= ROM_content(to_integer(address));
  END IF;
END PROCESS proc_name;END RTL;